diff --git a/lib/ethdev/ethdev_sff_telemetry.c b/lib/ethdev/ethdev_sff_telemetry.c
new file mode 100644
index 0000000000..f756b9643f
--- /dev/null
+++ b/lib/ethdev/ethdev_sff_telemetry.c
@@ -0,0 +1,138 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright(c) 2022 Intel Corporation
+ */
+
+#include <errno.h>
+
+#include <rte_ethdev.h>
+#include <rte_common.h>
+#include "ethdev_sff_telemetry.h"
+#include "telemetry_data.h"
+
+static void
+sff_port_module_eeprom_parse(uint16_t port_id, struct rte_tel_data *d)
+{
+	struct rte_eth_dev_module_info minfo;
+	struct rte_dev_eeprom_info einfo;
+	int ret;
+
+	if (d == NULL) {
+		RTE_ETHDEV_LOG(ERR, "Dict invalid\n");
+		return;
+	}
+
+	ret = rte_eth_dev_get_module_info(port_id, &minfo);
+	if (ret != 0) {
+		switch (ret) {
+		case -ENODEV:
+			RTE_ETHDEV_LOG(ERR, "port index %d invalid\n", port_id);
+			break;
+		case -ENOTSUP:
+			RTE_ETHDEV_LOG(ERR, "operation not supported by device\n");
+			break;
+		case -EIO:
+			RTE_ETHDEV_LOG(ERR, "device is removed\n");
+			break;
+		default:
+			RTE_ETHDEV_LOG(ERR, "Unable to get port module info, %d\n", ret);
+			break;
+		}
+		return;
+	}
+
+	einfo.offset = 0;
+	einfo.length = minfo.eeprom_len;
+	einfo.data = calloc(1, minfo.eeprom_len);
+	if (einfo.data == NULL) {
+		RTE_ETHDEV_LOG(ERR, "Allocation of port %u eeprom data failed\n", port_id);
+		return;
+	}
+
+	ret = rte_eth_dev_get_module_eeprom(port_id, &einfo);
+	if (ret != 0) {
+		switch (ret) {
+		case -ENODEV:
+			RTE_ETHDEV_LOG(ERR, "port index %d invalid\n", port_id);
+			break;
+		case -ENOTSUP:
+			RTE_ETHDEV_LOG(ERR, "operation not supported by device\n");
+			break;
+		case -EIO:
+			RTE_ETHDEV_LOG(ERR, "device is removed\n");
+			break;
+		default:
+			RTE_ETHDEV_LOG(ERR, "Unable to get port module EEPROM, %d\n", ret);
+			break;
+		}
+		free(einfo.data);
+		return;
+	}
+
+	switch (minfo.type) {
+	/* parsing module EEPROM data base on different module type */
+	default:
+		RTE_ETHDEV_LOG(NOTICE, "Unsupported module type: %u\n", minfo.type);
+		break;
+	}
+
+	free(einfo.data);
+}
+
+void
+ssf_add_dict_string(struct rte_tel_data *d, const char *name_str, const char *value_str)
+{
+	struct tel_dict_entry *e = &d->data.dict[d->data_len];
+
+	if (d->type != RTE_TEL_DICT)
+		return;
+	if (d->data_len >= RTE_TEL_MAX_DICT_ENTRIES) {
+		RTE_ETHDEV_LOG(ERR, "data_len has exceeded the maximum number of inserts\n");
+		return;
+	}
+
+	e->type = RTE_TEL_STRING_VAL;
+	/* append different values for same keys */
+	if (d->data_len > 0) {
+		struct tel_dict_entry *previous = &d->data.dict[d->data_len - 1];
+		if (strcmp(previous->name, name_str) == 0) {
+			strlcat(previous->value.sval, "; ", RTE_TEL_MAX_STRING_LEN);
+			strlcat(previous->value.sval, value_str, RTE_TEL_MAX_STRING_LEN);
+			goto end;
+		}
+	}
+	strlcpy(e->value.sval, value_str, RTE_TEL_MAX_STRING_LEN);
+	strlcpy(e->name, name_str, RTE_TEL_MAX_STRING_LEN);
+	d->data_len++;
+
+end:
+	return;
+}
+
+int
+eth_dev_handle_port_module_eeprom(const char *cmd __rte_unused, const char *params,
+				  struct rte_tel_data *d)
+{
+	char *end_param;
+	int port_id;
+
+	if (params == NULL || strlen(params) == 0 || !isdigit(*params))
+		return -1;
+
+	errno = 0;
+	port_id = strtoul(params, &end_param, 0);
+
+	if (errno != 0) {
+		RTE_ETHDEV_LOG(ERR, "Invalid argument\n");
+		return -1;
+	}
+
+	if (*end_param != '\0')
+		RTE_ETHDEV_LOG(NOTICE,
+			"Extra parameters passed to ethdev telemetry command, ignoring\n");
+
+	rte_tel_data_start_dict(d);
+
+	sff_port_module_eeprom_parse(port_id, d);
+
+	return 0;
+}
diff --git a/lib/ethdev/ethdev_sff_telemetry.h b/lib/ethdev/ethdev_sff_telemetry.h
new file mode 100644
index 0000000000..1fd870e0ef
--- /dev/null
+++ b/lib/ethdev/ethdev_sff_telemetry.h
@@ -0,0 +1,27 @@
+/* SPDX-License-Identifier: BSD-3-Clause
+ * Copyright(c) 2022 Intel Corporation
+ */
+
+#ifndef _ETHDEV_SFF_TELEMETRY_H_
+#define _ETHDEV_SFF_TELEMETRY_H_
+
+#include <rte_telemetry.h>
+
+#define SFF_ITEM_VAL_COMPOSE_SIZE 64
+
+/* SFF-8079 Optics diagnostics */
+void sff_8079_show_all(const uint8_t *data, struct rte_tel_data *d);
+
+/* SFF-8472 Optics diagnostics */
+void sff_8472_show_all(const uint8_t *data, struct rte_tel_data *d);
+
+/* SFF-8636 Optics diagnostics */
+void sff_8636_show_all(const uint8_t *data, uint32_t eeprom_len, struct rte_tel_data *d);
+
+int eth_dev_handle_port_module_eeprom(const char *cmd __rte_unused,
+				      const char *params,
+				      struct rte_tel_data *d);
+
+void ssf_add_dict_string(struct rte_tel_data *d, const char *name_str, const char *value_str);
+
+#endif /* _ETHDEV_SFF_TELEMETRY_H_ */
diff --git a/lib/ethdev/meson.build b/lib/ethdev/meson.build
index a094585bf7..49c77acb3f 100644
--- a/lib/ethdev/meson.build
+++ b/lib/ethdev/meson.build
@@ -11,6 +11,7 @@ sources = files(
         'rte_flow.c',
         'rte_mtr.c',
         'rte_tm.c',
+        'ethdev_sff_telemetry.c',
 )
 
 headers = files(
diff --git a/lib/ethdev/rte_ethdev.c b/lib/ethdev/rte_ethdev.c
index 29a3d80466..2b87df1b32 100644
--- a/lib/ethdev/rte_ethdev.c
+++ b/lib/ethdev/rte_ethdev.c
@@ -39,6 +39,7 @@
 #include "ethdev_driver.h"
 #include "ethdev_profile.h"
 #include "ethdev_private.h"
+#include "ethdev_sff_telemetry.h"
 
 struct rte_eth_dev rte_eth_devices[RTE_MAX_ETHPORTS];
 
@@ -5876,4 +5877,6 @@ RTE_INIT(ethdev_init_telemetry)
 			"Returns the link status for a port. Parameters: int port_id");
 	rte_telemetry_register_cmd("/ethdev/info", eth_dev_handle_port_info,
 			"Returns the device info for a port. Parameters: int port_id");
+	rte_telemetry_register_cmd("/ethdev/module_eeprom", eth_dev_handle_port_module_eeprom,
+			"Returns module EEPROM info with SFF specs. Parameters: int port_id");
 }